
#include <PalmOS.h>
#include <VfsMgr.h>
#include "zgrabrsc.h"
#include "zgrab.h"
#include "stdfile.h"
#include "bmp.h"
#include "endianutils.h"

// unfinished

int SaveBMP ( char *filename, UInt8 *image,
	      UInt32 width, UInt32 height, UInt8 bpp16 )
{
  bmp_header_t header;
  bmp_info_t info;
  UInt16 *image16 = (UInt16*) image;
  FILE *file;
  UInt16 witer, hiter;
  UInt16 c;

  // only support 16bpp!
  if ( ! bpp16 ) {
    return ( 0 );
  }

  // open
  file = fopen ( filename, "wb" );

  if ( ! file ) {
    return ( 0 );
  }

  // header
  header.type = ByteSwap16 ( 'BM' );
  header.size = sizeof(bmp_header_t) + sizeof(bmp_info_t) +
    ( width * height * 4 );
  header.size = ByteSwap32 ( header.size );
  header.reserved1 = 0;
  header.reserved2 = 0;
  header.offset = ByteSwap32 ( sizeof(bmp_header_t) + sizeof(bmp_info_t) );

  fwrite ( &header, sizeof(bmp_header_t), 1, file );

  // info
  info.size = ByteSwap32 ( sizeof ( bmp_info_t ) );
  info.width = ByteSwap32 ( width );
  info.height = ByteSwap32 ( height );
  info.planes = ByteSwap16 ( 1 );
  info.bits = ByteSwap16 ( 24 ); // 24bpp
  info.compression = ByteSwap32 ( bmpCompressNone );
  info.imagesize = 0; //ByteSwap32 ( width * height * 2 );
  info.xresolution = 0; //ByteSwap32 ( 96 );
  info.yresolution = 0; //ByteSwap32 ( 96 );
  info.ncolours = 0; //ByteSwap32 ( 0xFFFF );
  info.importantcolours = 0;

  fwrite ( &info, sizeof(bmp_info_t), 1, file );

  // image data
  for ( hiter = 0; hiter < height; hiter++ ) {
    for ( witer = 0; witer < width; witer++ ) {
      // RGB == R5 G6 B5
      // c = ( r << 11 ) | ( g << 5 ) | b;
      c = *image16++;

      fputc ( ( c >> 11 ) & 0x1F, file ); // r
      fputc ( ( c >> 5 ) & 0x3F, file ); // g
      fputc ( c & 0x1F, file ); // b
      fputc ( 0, file ); // pad

    }
  }

  fclose ( file );

  return ( 1 );
}
