
#ifndef h_stdfile_h
#define h_stdfile_h

/*
 * stdfile has some cheapy implementations of common stdio FILE functions.
 * This isn't the most recent of complete version of stdfile.c -- see Zot
 * ZQuake or the like. However, for most quickie game ports or the like
 * this stdfile will work great (most things just open and read).
 *
 * stdfile.c assumes it works in one directory, though some versions of it
 * have fcwd or the like for changing the directory. I don't recall as this
 * is a pretty hold hack of a project.
 */

/* define if you want a alert to show each function as entered
 */
//#define DEBUGFILE 1
#define TAILMAX 8192

/* simulate stdio FILE using VFS; why not?
 */
typedef struct {
  char filename [ 34 ]; // for fun
  UInt32 size; // get file size (for read types)
  FileRef ref;
  UInt8 bufferp; // 1 for buffered input, 2 for output, 0 no buffering
  char buffer [ TAILMAX ];
  UInt16 tail;
} FILE;
//#define FILE FileRef

#define stderr ((FILE*) 37)
#define stdin ((FILE*) 36)
#define stdout ((FILE*) 35)

#define SEEK_SET vfsOriginBeginning
#define SEEK_CUR vfsOriginCurrent
#define SEEK_END vfsOriginEnd

FILE *fopen ( signed char *filename, char *mode );
Int8 fclose ( FILE *file );
Int8 fseek ( FILE *file, UInt32 rel, UInt16 source );
UInt32 fread ( char *buf, UInt32 size, UInt32 num, FILE *file );
UInt32 fwrite ( char *buf, UInt32 size, UInt32 num, FILE *file );
int fgetc ( FILE *file );
int fputs ( const char *str, FILE *stream );
int fputc ( UInt8 c, FILE *file );
UInt32 ftell ( FILE *file );
int fprintf ( FILE *file, char *fmt, ... );
#define ferror(f) 0
#define feof(x) 0
long int fscanf_get_d ( FILE *f );
char fscanf_get_c ( FILE *f );

/* special extensions
 */
#define STDTEMPFILE "KronosTemp"

MemHandle pdb_temp_open ( char *filename ); // copy to RAM and open
void pdb_temp_close ( char *filename );     // back to VFS and delete temp

UInt8 file_exists ( char *filename );
UInt8 file_delete ( char *filename );

#endif
